package com.thoughtworks.gauge.autocomplete;

import com.intellij.codeInsight.completion.CompletionParameters;
import com.intellij.codeInsight.completion.CompletionProvider;
import com.intellij.codeInsight.completion.CompletionResultSet;
import com.intellij.codeInsight.completion.PlainPrefixMatcher;
import com.intellij.codeInsight.lookup.LookupElementBuilder;
import com.intellij.util.ProcessingContext;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class DynamicArgCompletionProvider extends CompletionProvider<CompletionParameters> {
    public void addCompletions(@NotNull CompletionParameters parameters, ProcessingContext context, @NotNull CompletionResultSet resultSet) {
        resultSet.withPrefixMatcher(new PlainPrefixMatcher(""));
        List<String> args = getDynamicargs();
        for (String arg : args) {
            LookupElementBuilder element = LookupElementBuilder.create(arg);
            resultSet.addElement(element);
        }
    }

    private List<String> getDynamicargs() {
        return new ArrayList<String>() {{
            add("dynamic arg1");
            add("dynamic arg2");
            add("dybamic foo");
            add("bar");
        }};
    }


}