package com.thoughtworks.gauge.autocomplete;

import com.intellij.codeInsight.completion.CompletionParameters;
import com.intellij.codeInsight.completion.CompletionProvider;
import com.intellij.codeInsight.completion.CompletionResultSet;
import com.intellij.codeInsight.completion.PlainPrefixMatcher;
import com.intellij.codeInsight.lookup.LookupElementBuilder;
import com.intellij.util.ProcessingContext;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class StaticArgCompletionProvider extends CompletionProvider<CompletionParameters> {
    @Override
    protected void addCompletions(@NotNull CompletionParameters parameters, ProcessingContext context, @NotNull CompletionResultSet resultSet) {
        resultSet.withPrefixMatcher(new PlainPrefixMatcher(""));
        List<String> args = getStaticArgs();
        for (String arg : args) {
            LookupElementBuilder element = LookupElementBuilder.create(arg);
            resultSet.addElement(element);
        }
    }

    private List<String> getStaticArgs() {
        return new ArrayList<String>() {{
           add("arg1");
           add("arg2");
           add("arg3");
           add("foo");
           add("bar");
        }};
    }
}
