package com.thoughtworks.gauge.autocomplete;

import com.intellij.codeInsight.completion.CompletionParameters;
import com.intellij.codeInsight.completion.CompletionProvider;
import com.intellij.codeInsight.completion.CompletionResultSet;
import com.intellij.codeInsight.completion.PlainPrefixMatcher;
import com.intellij.codeInsight.lookup.LookupElementBuilder;
import com.intellij.openapi.project.Project;
import com.intellij.util.ProcessingContext;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class StepCompletionProvider extends CompletionProvider<CompletionParameters> {

    public void addCompletions(@NotNull CompletionParameters parameters, ProcessingContext context, @NotNull CompletionResultSet resultSet) {
        resultSet.withPrefixMatcher(new PlainPrefixMatcher(""));
        for (String step : getStepsInProject(parameters.getOriginalFile().getProject())) {
            LookupElementBuilder element = LookupElementBuilder.create(step);
            resultSet.addElement(element);
        }
    }

    private List<String> getStepsInProject(Project project) {
        return new ArrayList<String>(){{
            add("task1");
            add("task2");
            add("another task");
            add("random task");
        }};
    }
}